#ifndef MOBIES_CTREE_H
#define MOBIES_CTREE_H
// header file CTree.h generated from diagram CTree
// generated on Wed Mar 17 18:23:25 2004

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif



namespace CTree {

	typedef Udm::Object Object;

	class  RootConnection;
	class  Root;
	class  CTreeModel;
	class  Connection;
	class  Classification;
	class  Composition;
	class  Class;
	class  FCO;
	class  CTE;
	class  InputData;
	class  OutputData;
	class  DataContainsConnection;
	class  Helper;
	class  DataConnection;
	class  DataFCO;
	class  RootFolder;
	class  MgaObject;

	  void Initialize();
	extern  Udm::UdmDiagram diagram;

	class  CTE :  public Object {
	 public:
		static Uml::Class meta;

		CTE() { }
		CTE(Udm::ObjectImpl *impl) : Object(impl) { }
		CTE(const CTE &master) : Object(master) { }
		static CTE Cast(const Object &a) { return __Cast(a, meta); }

		static CTE Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		CTE CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		CTE CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<CTE> Instances() { return Udm::InstantiatedAttr<CTree::CTE>(impl);}

		Udm::DerivedAttr<CTree::CTE> Derived() { return Udm::DerivedAttr<CTree::CTE>(impl);}

		Udm::ArchetypeAttr<CTree::CTE> Archetype() { return Udm::ArchetypeAttr<CTree::CTE>(impl);}

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::CompositionChildRole meta_CTreeModel_children;
		Udm::ChildrenAttr<CTree::CTreeModel> CTreeModel_children() const { return Udm::ChildrenAttr<CTree::CTreeModel>(impl, meta_CTreeModel_children); }

		Udm::ChildrenAttr<CTree::CTreeModel> CTreeModel_kind_children() const { return Udm::ChildrenAttr<CTree::CTreeModel>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<CTree::MgaObject>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<CTree::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<CTree::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<CTree::RootFolder> parent() const { return Udm::ParentAttr<CTree::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

	class  RootFolder :  public Object {
	 public:
		static Uml::Class meta;

		RootFolder() { }
		RootFolder(Udm::ObjectImpl *impl) : Object(impl) { }
		RootFolder(const RootFolder &master) : Object(master) { }
		static RootFolder Cast(const Object &a) { return __Cast(a, meta); }

		static RootFolder Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		RootFolder CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		RootFolder CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<RootFolder> Instances() { return Udm::InstantiatedAttr<CTree::RootFolder>(impl);}

		Udm::DerivedAttr<CTree::RootFolder> Derived() { return Udm::DerivedAttr<CTree::RootFolder>(impl);}

		Udm::ArchetypeAttr<CTree::RootFolder> Archetype() { return Udm::ArchetypeAttr<CTree::RootFolder>(impl);}

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::CompositionChildRole meta_RootFolder_children;
		Udm::ChildrenAttr<CTree::RootFolder> RootFolder_children() const { return Udm::ChildrenAttr<CTree::RootFolder>(impl, meta_RootFolder_children); }

		static Uml::CompositionChildRole meta_CTE_children;
		Udm::ChildrenAttr<CTree::CTE> CTE_children() const { return Udm::ChildrenAttr<CTree::CTE>(impl, meta_CTE_children); }

		Udm::ChildrenAttr<CTree::CTE> CTE_kind_children() const { return Udm::ChildrenAttr<CTree::CTE>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::RootFolder> RootFolder_kind_children() const { return Udm::ChildrenAttr<CTree::RootFolder>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<CTree::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<CTree::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<CTree::RootFolder> parent() const { return Udm::ParentAttr<CTree::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

	class  MgaObject :  public Object {
	 public:
		static Uml::Class meta;

		MgaObject() { }
		MgaObject(Udm::ObjectImpl *impl) : Object(impl) { }
		MgaObject(const MgaObject &master) : Object(master) { }
		static MgaObject Cast(const Object &a) { return __Cast(a, meta); }

		static MgaObject Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		MgaObject CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		MgaObject CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<MgaObject> Instances() { return Udm::InstantiatedAttr<CTree::MgaObject>(impl);}

		Udm::DerivedAttr<CTree::MgaObject> Derived() { return Udm::DerivedAttr<CTree::MgaObject>(impl);}

		Udm::ArchetypeAttr<CTree::MgaObject> Archetype() { return Udm::ArchetypeAttr<CTree::MgaObject>(impl);}

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  RootConnection :  public MgaObject {
	 public:
		static Uml::Class meta;

		RootConnection() { }
		RootConnection(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		RootConnection(const RootConnection &master) : MgaObject(master) { }
		static RootConnection Cast(const Object &a) { return __Cast(a, meta); }

		static RootConnection Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		RootConnection CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		RootConnection CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<RootConnection> Instances() { return Udm::InstantiatedAttr<CTree::RootConnection>(impl);}

		Udm::DerivedAttr<CTree::RootConnection> Derived() { return Udm::DerivedAttr<CTree::RootConnection>(impl);}

		Udm::ArchetypeAttr<CTree::RootConnection> Archetype() { return Udm::ArchetypeAttr<CTree::RootConnection>(impl);}

		static Uml::CompositionParentRole meta_CTreeModel_parent;
		Udm::ParentAttr<CTree::CTreeModel> CTreeModel_parent() const { return Udm::ParentAttr<CTree::CTreeModel>(impl, meta_CTreeModel_parent); }

		Udm::ParentAttr<CTree::MgaObject> parent() const { return Udm::ParentAttr<CTree::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dstRootConnection_end_;
		Udm::AssocEndAttr<CTree::FCO> dstRootConnection_end() const { return Udm::AssocEndAttr<CTree::FCO>(impl, meta_dstRootConnection_end_); }

		static Uml::AssociationRole meta_srcRootConnection_end_;
		Udm::AssocEndAttr<CTree::Root> srcRootConnection_end() const { return Udm::AssocEndAttr<CTree::Root>(impl, meta_srcRootConnection_end_); }

		static Uml::Constraint meta_RootCombinationConstraint;
	};

	class  Root :  public MgaObject {
	 public:
		static Uml::Class meta;

		Root() { }
		Root(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Root(const Root &master) : MgaObject(master) { }
		static Root Cast(const Object &a) { return __Cast(a, meta); }

		static Root Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Root CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Root CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Root> Instances() { return Udm::InstantiatedAttr<CTree::Root>(impl);}

		Udm::DerivedAttr<CTree::Root> Derived() { return Udm::DerivedAttr<CTree::Root>(impl);}

		Udm::ArchetypeAttr<CTree::Root> Archetype() { return Udm::ArchetypeAttr<CTree::Root>(impl);}

		static Uml::Attribute meta_StartTime;
		Udm::StringAttr StartTime() const { return Udm::StringAttr(impl, meta_StartTime); }

		static Uml::Attribute meta_Solver;
		Udm::StringAttr Solver() const { return Udm::StringAttr(impl, meta_Solver); }

		static Uml::Attribute meta_StopTime;
		Udm::StringAttr StopTime() const { return Udm::StringAttr(impl, meta_StopTime); }

		static Uml::Attribute meta_FixedStep;
		Udm::StringAttr FixedStep() const { return Udm::StringAttr(impl, meta_FixedStep); }

		static Uml::AssociationRole meta_dstRootConnection, meta_dstRootConnection_rev;
		Udm::AClassAssocAttr<CTree::RootConnection, CTree::FCO> dstRootConnection() const { return Udm::AClassAssocAttr<CTree::RootConnection, CTree::FCO>(impl, meta_dstRootConnection, meta_dstRootConnection_rev); }

		static Uml::CompositionParentRole meta_CTreeModel_parent;
		Udm::ParentAttr<CTree::CTreeModel> CTreeModel_parent() const { return Udm::ParentAttr<CTree::CTreeModel>(impl, meta_CTreeModel_parent); }

		Udm::ParentAttr<CTree::MgaObject> parent() const { return Udm::ParentAttr<CTree::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  CTreeModel :  public MgaObject {
	 public:
		static Uml::Class meta;

		CTreeModel() { }
		CTreeModel(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		CTreeModel(const CTreeModel &master) : MgaObject(master) { }
		static CTreeModel Cast(const Object &a) { return __Cast(a, meta); }

		static CTreeModel Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		CTreeModel CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		CTreeModel CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<CTreeModel> Instances() { return Udm::InstantiatedAttr<CTree::CTreeModel>(impl);}

		Udm::DerivedAttr<CTree::CTreeModel> Derived() { return Udm::DerivedAttr<CTree::CTreeModel>(impl);}

		Udm::ArchetypeAttr<CTree::CTreeModel> Archetype() { return Udm::ArchetypeAttr<CTree::CTreeModel>(impl);}

		static Uml::CompositionChildRole meta_Connection_children;
		Udm::ChildrenAttr<CTree::Connection> Connection_children() const { return Udm::ChildrenAttr<CTree::Connection>(impl, meta_Connection_children); }

		static Uml::CompositionChildRole meta_RootConnection_children;
		Udm::ChildrenAttr<CTree::RootConnection> RootConnection_children() const { return Udm::ChildrenAttr<CTree::RootConnection>(impl, meta_RootConnection_children); }

		static Uml::CompositionChildRole meta_Root_child;
		Udm::ChildAttr<CTree::Root> Root_child() const { return Udm::ChildAttr<CTree::Root>(impl, meta_Root_child); }

		static Uml::CompositionChildRole meta_FCO_children;
		Udm::ChildrenAttr<CTree::FCO> FCO_children() const { return Udm::ChildrenAttr<CTree::FCO>(impl, meta_FCO_children); }

		static Uml::CompositionChildRole meta_Helper_children;
		Udm::ChildrenAttr<CTree::Helper> Helper_children() const { return Udm::ChildrenAttr<CTree::Helper>(impl, meta_Helper_children); }

		static Uml::CompositionChildRole meta_DataFCO_children;
		Udm::ChildrenAttr<CTree::DataFCO> DataFCO_children() const { return Udm::ChildrenAttr<CTree::DataFCO>(impl, meta_DataFCO_children); }

		static Uml::CompositionChildRole meta_DataContainsConnection_children;
		Udm::ChildrenAttr<CTree::DataContainsConnection> DataContainsConnection_children() const { return Udm::ChildrenAttr<CTree::DataContainsConnection>(impl, meta_DataContainsConnection_children); }

		static Uml::CompositionChildRole meta_DataConnection_children;
		Udm::ChildrenAttr<CTree::DataConnection> DataConnection_children() const { return Udm::ChildrenAttr<CTree::DataConnection>(impl, meta_DataConnection_children); }

		Udm::ChildrenAttr<CTree::RootConnection> RootConnection_kind_children() const { return Udm::ChildrenAttr<CTree::RootConnection>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::Root> Root_kind_children() const { return Udm::ChildrenAttr<CTree::Root>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::Connection> Connection_kind_children() const { return Udm::ChildrenAttr<CTree::Connection>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::Classification> Classification_kind_children() const { return Udm::ChildrenAttr<CTree::Classification>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::Composition> Composition_kind_children() const { return Udm::ChildrenAttr<CTree::Composition>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::Class> Class_kind_children() const { return Udm::ChildrenAttr<CTree::Class>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::FCO> FCO_kind_children() const { return Udm::ChildrenAttr<CTree::FCO>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::InputData> InputData_kind_children() const { return Udm::ChildrenAttr<CTree::InputData>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::OutputData> OutputData_kind_children() const { return Udm::ChildrenAttr<CTree::OutputData>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::DataContainsConnection> DataContainsConnection_kind_children() const { return Udm::ChildrenAttr<CTree::DataContainsConnection>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::Helper> Helper_kind_children() const { return Udm::ChildrenAttr<CTree::Helper>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::DataConnection> DataConnection_kind_children() const { return Udm::ChildrenAttr<CTree::DataConnection>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::DataFCO> DataFCO_kind_children() const { return Udm::ChildrenAttr<CTree::DataFCO>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<CTree::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<CTree::MgaObject>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_CTE_parent;
		Udm::ParentAttr<CTree::CTE> CTE_parent() const { return Udm::ParentAttr<CTree::CTE>(impl, meta_CTE_parent); }

		Udm::ParentAttr<CTree::CTE> parent() const { return Udm::ParentAttr<CTree::CTE>(impl, Udm::NULLPARENTROLE); }
	};

	class  Connection :  public MgaObject {
	 public:
		static Uml::Class meta;

		Connection() { }
		Connection(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Connection(const Connection &master) : MgaObject(master) { }
		static Connection Cast(const Object &a) { return __Cast(a, meta); }

		static Connection Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Connection CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Connection CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Connection> Instances() { return Udm::InstantiatedAttr<CTree::Connection>(impl);}

		Udm::DerivedAttr<CTree::Connection> Derived() { return Udm::DerivedAttr<CTree::Connection>(impl);}

		Udm::ArchetypeAttr<CTree::Connection> Archetype() { return Udm::ArchetypeAttr<CTree::Connection>(impl);}

		static Uml::CompositionParentRole meta_CTreeModel_parent;
		Udm::ParentAttr<CTree::CTreeModel> CTreeModel_parent() const { return Udm::ParentAttr<CTree::CTreeModel>(impl, meta_CTreeModel_parent); }

		Udm::ParentAttr<CTree::MgaObject> parent() const { return Udm::ParentAttr<CTree::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_srcConnection_end_;
		Udm::AssocEndAttr<CTree::FCO> srcConnection_end() const { return Udm::AssocEndAttr<CTree::FCO>(impl, meta_srcConnection_end_); }

		static Uml::AssociationRole meta_dstConnection_end_;
		Udm::AssocEndAttr<CTree::FCO> dstConnection_end() const { return Udm::AssocEndAttr<CTree::FCO>(impl, meta_dstConnection_end_); }

		static Uml::Constraint meta_ClassificationConstraint;
		static Uml::Constraint meta_CheckSelfConnections;
		static Uml::Constraint meta_ClassConstraint;
		static Uml::Constraint meta_CompositionConstraint;
	};

	class  FCO :  public MgaObject {
	 public:
		static Uml::Class meta;

		FCO() { }
		FCO(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		FCO(const FCO &master) : MgaObject(master) { }
		static FCO Cast(const Object &a) { return __Cast(a, meta); }

		static FCO Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		FCO CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		FCO CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<FCO> Instances() { return Udm::InstantiatedAttr<CTree::FCO>(impl);}

		Udm::DerivedAttr<CTree::FCO> Derived() { return Udm::DerivedAttr<CTree::FCO>(impl);}

		Udm::ArchetypeAttr<CTree::FCO> Archetype() { return Udm::ArchetypeAttr<CTree::FCO>(impl);}

		static Uml::AssociationRole meta_srcRootConnection, meta_srcRootConnection_rev;
		Udm::AClassAssocAttr<CTree::RootConnection, CTree::Root> srcRootConnection() const { return Udm::AClassAssocAttr<CTree::RootConnection, CTree::Root>(impl, meta_srcRootConnection, meta_srcRootConnection_rev); }

		static Uml::AssociationRole meta_dstConnection, meta_dstConnection_rev;
		Udm::AClassAssocAttr<CTree::Connection, CTree::FCO> dstConnection() const { return Udm::AClassAssocAttr<CTree::Connection, CTree::FCO>(impl, meta_dstConnection, meta_dstConnection_rev); }

		static Uml::AssociationRole meta_srcConnection, meta_srcConnection_rev;
		Udm::AClassAssocAttr<CTree::Connection, CTree::FCO> srcConnection() const { return Udm::AClassAssocAttr<CTree::Connection, CTree::FCO>(impl, meta_srcConnection, meta_srcConnection_rev); }

		static Uml::CompositionParentRole meta_CTreeModel_parent;
		Udm::ParentAttr<CTree::CTreeModel> CTreeModel_parent() const { return Udm::ParentAttr<CTree::CTreeModel>(impl, meta_CTreeModel_parent); }

		Udm::ParentAttr<CTree::MgaObject> parent() const { return Udm::ParentAttr<CTree::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::Constraint meta_Constraint;
	};

	class  Classification :  public FCO {
	 public:
		static Uml::Class meta;

		Classification() { }
		Classification(Udm::ObjectImpl *impl) : FCO(impl) { }
		Classification(const Classification &master) : FCO(master) { }
		static Classification Cast(const Object &a) { return __Cast(a, meta); }

		static Classification Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Classification CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Classification CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Classification> Instances() { return Udm::InstantiatedAttr<CTree::Classification>(impl);}

		Udm::DerivedAttr<CTree::Classification> Derived() { return Udm::DerivedAttr<CTree::Classification>(impl);}

		Udm::ArchetypeAttr<CTree::Classification> Archetype() { return Udm::ArchetypeAttr<CTree::Classification>(impl);}

		static Uml::Attribute meta_order;
		Udm::IntegerAttr order() const { return Udm::IntegerAttr(impl, meta_order); }

		static Uml::Attribute meta_classificationType;
		Udm::StringAttr classificationType() const { return Udm::StringAttr(impl, meta_classificationType); }

		static Uml::AssociationRole meta_srcDataConnection, meta_srcDataConnection_rev;
		Udm::AClassAssocAttr<CTree::DataConnection, CTree::DataFCO> srcDataConnection() const { return Udm::AClassAssocAttr<CTree::DataConnection, CTree::DataFCO>(impl, meta_srcDataConnection, meta_srcDataConnection_rev); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  Composition :  public FCO {
	 public:
		static Uml::Class meta;

		Composition() { }
		Composition(Udm::ObjectImpl *impl) : FCO(impl) { }
		Composition(const Composition &master) : FCO(master) { }
		static Composition Cast(const Object &a) { return __Cast(a, meta); }

		static Composition Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Composition CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Composition CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Composition> Instances() { return Udm::InstantiatedAttr<CTree::Composition>(impl);}

		Udm::DerivedAttr<CTree::Composition> Derived() { return Udm::DerivedAttr<CTree::Composition>(impl);}

		Udm::ArchetypeAttr<CTree::Composition> Archetype() { return Udm::ArchetypeAttr<CTree::Composition>(impl);}

		static Uml::Attribute meta_compositionType;
		Udm::StringAttr compositionType() const { return Udm::StringAttr(impl, meta_compositionType); }

		static Uml::AssociationRole meta_srcDataContainsConnection, meta_srcDataContainsConnection_rev;
		Udm::AClassAssocAttr<CTree::DataContainsConnection, CTree::DataFCO> srcDataContainsConnection() const { return Udm::AClassAssocAttr<CTree::DataContainsConnection, CTree::DataFCO>(impl, meta_srcDataContainsConnection, meta_srcDataContainsConnection_rev); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  Class :  public FCO {
	 public:
		static Uml::Class meta;

		Class() { }
		Class(Udm::ObjectImpl *impl) : FCO(impl) { }
		Class(const Class &master) : FCO(master) { }
		static Class Cast(const Object &a) { return __Cast(a, meta); }

		static Class Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Class CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Class CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Class> Instances() { return Udm::InstantiatedAttr<CTree::Class>(impl);}

		Udm::DerivedAttr<CTree::Class> Derived() { return Udm::DerivedAttr<CTree::Class>(impl);}

		Udm::ArchetypeAttr<CTree::Class> Archetype() { return Udm::ArchetypeAttr<CTree::Class>(impl);}

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  DataContainsConnection :  public MgaObject {
	 public:
		static Uml::Class meta;

		DataContainsConnection() { }
		DataContainsConnection(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		DataContainsConnection(const DataContainsConnection &master) : MgaObject(master) { }
		static DataContainsConnection Cast(const Object &a) { return __Cast(a, meta); }

		static DataContainsConnection Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		DataContainsConnection CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		DataContainsConnection CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<DataContainsConnection> Instances() { return Udm::InstantiatedAttr<CTree::DataContainsConnection>(impl);}

		Udm::DerivedAttr<CTree::DataContainsConnection> Derived() { return Udm::DerivedAttr<CTree::DataContainsConnection>(impl);}

		Udm::ArchetypeAttr<CTree::DataContainsConnection> Archetype() { return Udm::ArchetypeAttr<CTree::DataContainsConnection>(impl);}

		static Uml::CompositionParentRole meta_CTreeModel_parent;
		Udm::ParentAttr<CTree::CTreeModel> CTreeModel_parent() const { return Udm::ParentAttr<CTree::CTreeModel>(impl, meta_CTreeModel_parent); }

		Udm::ParentAttr<CTree::MgaObject> parent() const { return Udm::ParentAttr<CTree::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dstDataContainsConnection_end_;
		Udm::AssocEndAttr<CTree::Composition> dstDataContainsConnection_end() const { return Udm::AssocEndAttr<CTree::Composition>(impl, meta_dstDataContainsConnection_end_); }

		static Uml::AssociationRole meta_srcDataContainsConnection_end_;
		Udm::AssocEndAttr<CTree::DataFCO> srcDataContainsConnection_end() const { return Udm::AssocEndAttr<CTree::DataFCO>(impl, meta_srcDataContainsConnection_end_); }

	};

	class  Helper :  public MgaObject {
	 public:
		static Uml::Class meta;

		Helper() { }
		Helper(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Helper(const Helper &master) : MgaObject(master) { }
		static Helper Cast(const Object &a) { return __Cast(a, meta); }

		static Helper Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Helper CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Helper CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Helper> Instances() { return Udm::InstantiatedAttr<CTree::Helper>(impl);}

		Udm::DerivedAttr<CTree::Helper> Derived() { return Udm::DerivedAttr<CTree::Helper>(impl);}

		Udm::ArchetypeAttr<CTree::Helper> Archetype() { return Udm::ArchetypeAttr<CTree::Helper>(impl);}

		static Uml::Attribute meta_strTemp2;
		Udm::StringAttr strTemp2() const { return Udm::StringAttr(impl, meta_strTemp2); }

		static Uml::Attribute meta_strTemp1;
		Udm::StringAttr strTemp1() const { return Udm::StringAttr(impl, meta_strTemp1); }

		static Uml::Attribute meta_intTemp1;
		Udm::IntegerAttr intTemp1() const { return Udm::IntegerAttr(impl, meta_intTemp1); }

		static Uml::Attribute meta_intTemp2;
		Udm::IntegerAttr intTemp2() const { return Udm::IntegerAttr(impl, meta_intTemp2); }

		static Uml::CompositionParentRole meta_CTreeModel_parent;
		Udm::ParentAttr<CTree::CTreeModel> CTreeModel_parent() const { return Udm::ParentAttr<CTree::CTreeModel>(impl, meta_CTreeModel_parent); }

		Udm::ParentAttr<CTree::MgaObject> parent() const { return Udm::ParentAttr<CTree::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  DataConnection :  public MgaObject {
	 public:
		static Uml::Class meta;

		DataConnection() { }
		DataConnection(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		DataConnection(const DataConnection &master) : MgaObject(master) { }
		static DataConnection Cast(const Object &a) { return __Cast(a, meta); }

		static DataConnection Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		DataConnection CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		DataConnection CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<DataConnection> Instances() { return Udm::InstantiatedAttr<CTree::DataConnection>(impl);}

		Udm::DerivedAttr<CTree::DataConnection> Derived() { return Udm::DerivedAttr<CTree::DataConnection>(impl);}

		Udm::ArchetypeAttr<CTree::DataConnection> Archetype() { return Udm::ArchetypeAttr<CTree::DataConnection>(impl);}

		static Uml::CompositionParentRole meta_CTreeModel_parent;
		Udm::ParentAttr<CTree::CTreeModel> CTreeModel_parent() const { return Udm::ParentAttr<CTree::CTreeModel>(impl, meta_CTreeModel_parent); }

		Udm::ParentAttr<CTree::MgaObject> parent() const { return Udm::ParentAttr<CTree::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dstDataConnection_end_;
		Udm::AssocEndAttr<CTree::Classification> dstDataConnection_end() const { return Udm::AssocEndAttr<CTree::Classification>(impl, meta_dstDataConnection_end_); }

		static Uml::AssociationRole meta_srcDataConnection_end_;
		Udm::AssocEndAttr<CTree::DataFCO> srcDataConnection_end() const { return Udm::AssocEndAttr<CTree::DataFCO>(impl, meta_srcDataConnection_end_); }

	};

	class  DataFCO :  public MgaObject {
	 public:
		static Uml::Class meta;

		DataFCO() { }
		DataFCO(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		DataFCO(const DataFCO &master) : MgaObject(master) { }
		static DataFCO Cast(const Object &a) { return __Cast(a, meta); }

		static DataFCO Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		DataFCO CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		DataFCO CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<DataFCO> Instances() { return Udm::InstantiatedAttr<CTree::DataFCO>(impl);}

		Udm::DerivedAttr<CTree::DataFCO> Derived() { return Udm::DerivedAttr<CTree::DataFCO>(impl);}

		Udm::ArchetypeAttr<CTree::DataFCO> Archetype() { return Udm::ArchetypeAttr<CTree::DataFCO>(impl);}

		static Uml::Attribute meta_dataType;
		Udm::StringAttr dataType() const { return Udm::StringAttr(impl, meta_dataType); }

		static Uml::Attribute meta_scope;
		Udm::StringAttr scope() const { return Udm::StringAttr(impl, meta_scope); }

		static Uml::Attribute meta_varName;
		Udm::StringAttr varName() const { return Udm::StringAttr(impl, meta_varName); }

		static Uml::Attribute meta_action;
		Udm::StringAttr action() const { return Udm::StringAttr(impl, meta_action); }

		static Uml::AssociationRole meta_dstDataConnection, meta_dstDataConnection_rev;
		Udm::AClassAssocAttr<CTree::DataConnection, CTree::Classification> dstDataConnection() const { return Udm::AClassAssocAttr<CTree::DataConnection, CTree::Classification>(impl, meta_dstDataConnection, meta_dstDataConnection_rev); }

		static Uml::AssociationRole meta_dstDataContainsConnection, meta_dstDataContainsConnection_rev;
		Udm::AClassAssocAttr<CTree::DataContainsConnection, CTree::Composition> dstDataContainsConnection() const { return Udm::AClassAssocAttr<CTree::DataContainsConnection, CTree::Composition>(impl, meta_dstDataContainsConnection, meta_dstDataContainsConnection_rev); }

		static Uml::CompositionParentRole meta_CTreeModel_parent;
		Udm::ParentAttr<CTree::CTreeModel> CTreeModel_parent() const { return Udm::ParentAttr<CTree::CTreeModel>(impl, meta_CTreeModel_parent); }

		Udm::ParentAttr<CTree::MgaObject> parent() const { return Udm::ParentAttr<CTree::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  InputData :  public DataFCO {
	 public:
		static Uml::Class meta;

		InputData() { }
		InputData(Udm::ObjectImpl *impl) : DataFCO(impl) { }
		InputData(const InputData &master) : DataFCO(master) { }
		static InputData Cast(const Object &a) { return __Cast(a, meta); }

		static InputData Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		InputData CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		InputData CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<InputData> Instances() { return Udm::InstantiatedAttr<CTree::InputData>(impl);}

		Udm::DerivedAttr<CTree::InputData> Derived() { return Udm::DerivedAttr<CTree::InputData>(impl);}

		Udm::ArchetypeAttr<CTree::InputData> Archetype() { return Udm::ArchetypeAttr<CTree::InputData>(impl);}

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  OutputData :  public DataFCO {
	 public:
		static Uml::Class meta;

		OutputData() { }
		OutputData(Udm::ObjectImpl *impl) : DataFCO(impl) { }
		OutputData(const OutputData &master) : DataFCO(master) { }
		static OutputData Cast(const Object &a) { return __Cast(a, meta); }

		static OutputData Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		OutputData CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		OutputData CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<OutputData> Instances() { return Udm::InstantiatedAttr<CTree::OutputData>(impl);}

		Udm::DerivedAttr<CTree::OutputData> Derived() { return Udm::DerivedAttr<CTree::OutputData>(impl);}

		Udm::ArchetypeAttr<CTree::OutputData> Archetype() { return Udm::ArchetypeAttr<CTree::OutputData>(impl);}

		static Uml::Attribute meta_currentValue;
		Udm::IntegerAttr currentValue() const { return Udm::IntegerAttr(impl, meta_currentValue); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

}

#endif //MOBIES_CTREE_H
